<script lang="ts">
import {
  and,
  type ControlElement,
  formatIs,
  isStringControl,
  type JsonFormsRendererRegistryEntry,
  type JsonFormsSubStates,
  rankWith,
} from "@jsonforms/core";
import { rendererProps, type RendererProps, useJsonFormsControl } from "@jsonforms/vue";
import { ControlWrapper, DisabledIconFocus, useVuetifyControl } from "@jsonforms/vue-vuetify";
import every from "lodash/every";
import isArray from "lodash/isArray";
import isString from "lodash/isString";
import { defineComponent } from "vue";
import { VHover } from "vuetify/components";

const controlRenderer = defineComponent({
  /* eslint-disable vue/component-definition-name-casing */
  name: "ncbi-pubmed-id-control-renderer",
  /* eslint-enable */
  components: {
    ControlWrapper,
    VHover,
  },
  directives: {
    DisabledIconFocus,
  },
  props: {
    ...rendererProps<ControlElement>(),
  },
  setup(props: RendererProps<ControlElement>) {
    const control = useVuetifyControl(
      useJsonFormsControl(props),
      value => value || undefined,
      300,
    );

    // For information, if you want to change data in control, you must use control.handleChange()
    let initialValue = control.control.value.data;
    if (control.control.value.data === undefined) {
      control.handleChange("pubmedID", "");
      initialValue = "";
    } else {
      initialValue = control.control.value.data;
    }
    const search = ref();

    const listData = ref();
    const loading = ref();

    const jsonforms = inject<JsonFormsSubStates>("jsonforms");

    function handle(pathTitle, valueTitle, pathID, valueID) {
      control.handleChange(pathTitle, valueTitle);
      control.handleChange(pathID, valueID);
    }

    if (initialValue !== "") {
      listData.value = [
        {
          title: initialValue,
          value: initialValue,
        },
      ];
    }

    const onInput = async (val) => {
      if (!val) return false;
      loading.value = true;
      const baseUrl = "https://eutils.ncbi.nlm.nih.gov/entrez/eutils/";
      try {
        const esummaryParams = new URLSearchParams({
          db: "pubmed",
          id: val,
          retmode: "json",
        });

        const esummaryResponse = await fetch(`${baseUrl}esummary.fcgi?${esummaryParams}`);
        if (!esummaryResponse.ok) {
          throw new Error("Erreur lors de la recherche par ID");
        }

        const esummaryData = await esummaryResponse.json();
        const item = esummaryData.result[val];
        if (!item) {
          listData.value = [];
        }

        listData.value = [{ title: `${item.uid} [${item.title}]`, value: `${item.uid}::${item.title}` }];
      } catch (error) {
        console.error(error);
      }
      loading.value = false;
    };

    return { ...control, onInput, loading, search, listData, jsonforms, handle };
  },
  computed: {
    suggestions(): string[] | undefined {
      const suggestions = this.control.uischema.options?.suggestion;

      if (suggestions === undefined || !isArray(suggestions) || !every(suggestions, isString)) {
        // check for incorrect data
        return undefined;
      }
      return suggestions;
    },
  },
  watch: {
    control(value, oldValue) {
      const regex = /^(\d+)\./;
      const match = value.path.match(regex);
      const pos = match ? Number.parseInt(match[1], 10) : null;

      if (
        pos === null
        && "title" in this.jsonforms.core.data
        && this.jsonforms.core.data.title.includes("::")
      ) {
        const pathTitle = "title";
        const pathID = "pubmedID";
        const newVal = this.jsonforms.core.data.title.split("::")[0];
        if (newVal !== oldValue.data || value.data === undefined) {
          this.handle(pathTitle, this.jsonforms.core.data.title.split("::")[1], pathID, newVal);
          this.control.value = newVal;
          this.control.data = newVal;
        }
      } else if (
        pos !== null
        && "title" in this.jsonforms.core.data[pos]
        && this.jsonforms.core.data[pos].title.includes("::")
      ) {
        const pathTitle = `${pos}.title`;
        const pathID = `${pos}.pubmedID`;
        const newVal = this.jsonforms.core.data[pos].title.split("::")[0];
        if (newVal !== oldValue.data || value.data === undefined) {
          this.handle(pathTitle, this.jsonforms.core.data[pos].title.split("::")[1], pathID, newVal);
          this.control.value = newVal;
          this.control.data = newVal;
        }
      } else if (
        pos !== null
        && "identifier" in this.jsonforms.core.data[pos]
        && "title" in this.jsonforms.core.data[pos].identifier
        && this.jsonforms.core.data[pos].identifier.title.includes("::")) {
        const pathTitle = `${pos}.identifier.title`;
        const pathID = `${pos}.identifier.pubmedID`;
        const newVal = this.jsonforms.core.data[pos].identifier.title.split("::")[0];
        if (newVal !== oldValue.data || value.data === undefined) {
          this.handle(pathTitle, this.jsonforms.core.data[pos].identifier.title.split("::")[1], pathID, newVal);
          this.control.value = newVal;
          this.control.data = newVal;
        }
      }
    },
  },
});

export default controlRenderer;
export const entry: JsonFormsRendererRegistryEntry = {
  renderer: controlRenderer,
  tester: rankWith(100, and(isStringControl, formatIs("ncbi-pubmed-id"))),
};
</script>

<template>
  <ControlWrapper
    v-bind="controlWrapper"
    :styles="styles"
    :isFocused="isFocused"
    :appliedOptions="appliedOptions"
  >
    <VHover v-slot="{ isHovering }">
      <v-autocomplete
        :id="`${control.id}-input`"
        v-model:search-input="search"
        v-disabled-icon-focus
        :class="styles.control.input"
        :disabled="!control.enabled"
        :autofocus="appliedOptions.focus"
        :placeholder="appliedOptions.placeholder"
        :label="computedLabel"
        :hint="control.description"
        v-bind="vuetifyProps('v-autocomplete')"
        :persistent-hint="persistentHint()"
        :required="control.required"
        :error-messages="control.errors"
        :clearable="isHovering"
        :model-value="control.data"
        :items="listData"
        item-value="value"
        :loading="loading"
        @update:model-value="onChange"
        @update:search="onInput"
        @focus="handleFocus"
        @blur="handleBlur"
      />

      <a
        v-if="Number.isInteger(Number(control.data))"
        :href="`https://pubmed.ncbi.nlm.nih.gov/${control.data}/`"
        target="_blank"
      >
        Read in pubmed <v-icon icon="mdi-open-in-new" />
      </a>
    </VHover>
  </ControlWrapper>
</template>
